#!/usr/bin/env python3
import subprocess
import pyudev
import getpass
import socket
from gi.repository import GLib
from pydbus import SystemBus
import os
loop = GLib.MainLoop()
import time
import json
bus2=SystemBus()
asd, bsd = "", ""
def get_host_name():
    """获取当前用户名"""
    username = getpass.getuser()
    return  username

def get_host_time():
    """获取本机时间
    return: time_1
    """
    time_1=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
    return time_1

def get_host_ip():
    """
    查询本机ip地址
    :return: ip
    """
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        s.connect(('8.8.8.8', 80))
        ip = s.getsockname()[0]
    except Exception:
        return "127.0.0.1"
    return ip
class CDService(object):
    """
        <node>
            <interface name='com.kylin.kysdk.CDControl'>
                <method name='GetStatus'>
                <arg type='i' name='status' direction='out'/>
                </method>
                <method name='SetStatus'>
                <arg type='i' name='status' direction='in'/>
                <arg type='i' name='ret' direction='out'/>
                </method>
            </interface>
        </node>
    """
    def GetStatus(self):
        if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules'):
            return 0
        elif os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules'):
            return 1
        elif not (os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules') or os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules')):
            return 2

    def SetStatus(self, status):
        if status == 0:
            if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules'):
                os.remove('/etc/udev/rules.d/cd-burn-forbid-write.rules')
            if os.path.exists('/etc/udev/rules.d/cd-burn-allow.rules'):
                os.remove('/etc/udev/rules.d/cd-burn-allow.rules')
            if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules'):
                return 0

            context = pyudev.Context()
            sr_list = []
            sr1 = [""]
            try:
                sr = subprocess.getoutput("ls /dev | grep sr").split("\n")
            except Exception:
                pass
            try:
                if sr != sr1:
                    for i in sr:
                        zx = pyudev.Devices.from_device_file(context, '/dev/{}'.format(i))
                        b = str(zx)
                        c = b[b.rfind('target'):-12]
                        d = c[12:]
                        e = d.replace(':', ' ').strip("/")
                        sr_list.append(e)
                        # subprocess.getstatusoutput("sudo rm -r /dev/sr{}".format(i))
                        js0bj = json.dumps(sr_list)
                        try:
                            os.system("umount /dev/{}".format(i))
                        except Exception:
                            pass
                        f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(e)
                        os.system(f)
                        with open('/etc/cd.json', 'w') as file:
                            file.write(js0bj)
                else:
                    b = ""
                    with open('/etc/cd.json', 'w') as file:
                        file.write(b)
            except IndexError:
                b = ""
                with open('/etc/cd.json', 'w') as file:
                    file.write(b)

            try:
                with open('/etc/udev/rules.d/cd-burn-forbid-all.rules', 'w') as f:
                    f.write('''KERNEL=="sr[0-9]*",RUN+="/bin/cd2.sh"
KERNEL=="hd[a-z]",RUN+="/bin/cd2.sh"
                   ''')
                with open('/etc/udev/rules.d/1cd-burn-forbid-all.rules', 'w') as f:
                    f.write('''ACTION=="add",KERNEL=="sr[0-9]*",RUN+="/bin/cd0086.sh"
ACTION=="add",KERNEL=="hd[a-z]",RUN+="/bin/cd0086.sh"
                   ''')
                with open('/bin/cd2.sh', 'w') as k:
                    k.write('''#!/bin/bash
umount /dev/sr*
rm -r /dev/sr*''')
                    with open('/bin/cd0086.sh', 'w') as k:
                        k.write('''#!/bin/bash
python3 /usr/bin/cd-re.py 
umount /dev/sr*
rm -r /dev/sr*''')
            except IOError:
                return -1
            subprocess.getstatusoutput("chmod 555 /bin/cd2.sh")
            subprocess.getstatusoutput("chmod 555 /bin/cd0086.sh")
            subprocess.getstatusoutput("umount /dev/sr*")
            return 0
        elif status == 1:
            if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules'):
                return 0
            if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules'):
                os.remove('/etc/udev/rules.d/cd-burn-forbid-all.rules')
                asd =1
            else:
                asd = 2
            if os.path.exists('/etc/udev/rules.d/1cd-burn-forbid-all.rules'):
                os.remove('/etc/udev/rules.d/1cd-burn-forbid-all.rules')
            if os.path.exists('/etc/udev/rules.d/cd-burn-allow.rules'):
                os.remove('/etc/udev/rules.d/cd-burn-allow.rules')
            
            with open('/etc/udev/rules.d/cd-burn-forbid-write.rules', 'w') as f:
                f.write('''KERNEL=="sr[0-9]*",RUN+="/bin/cd33.sh"
            KERNEL=="hd[0-9]*",RUN+="/bin/cd33.sh"
            ACTION=="add",KERNEL=="sr[0-9]*",RUN+="/bin/cd33.sh"
            ACTION=="add",KERNEL=="hd[a-z]",RUN+="/bin/cd33.sh"
            ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_FS_USAGE}=="filesystem",RUN+="/bin/cd.sh"
            ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_FS_USAGE}=="filesystem",RUN+="/bin/cd.sh"
            ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_CDROM_MEDIA_STATE}=="blank",RUN+="/bin/cd44.sh"
            ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_CDROM_MEDIA_STATE}=="blank",RUN+="/bin/cd44.sh"
            ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_EJECT_REQUEST}=="1",RUN+="/bin/cd1.sh"
            ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_EJECT_REQUEST}=="1",RUN+="/bin/cd1.sh"
                                               ''')
            with open('/bin/cd33.sh', 'w') as k:
                k.write('''#!/bin/bash
chmod 444 /dev/sr*
systemctl restart cdmonitor.service''')

            with open('/bin/cd44.sh', 'w') as k:
                k.write('''#!/bin/bash
chmod 444 /dev/sr*
python3 /usr/bin/read_in_blank.py''')
            with open('/bin/cd.sh', 'w') as k:
                k.write('''#!/bin/bash
chmod 444 /dev/sr*
python3 /usr/bin/read_in.py''')
            with open('/bin/cd1.sh', 'w') as k:
                k.write('''#!/bin/bash
chmod 444 /dev/sr*
python3 /usr/bin/read_out.py''')
            subprocess.getstatusoutput("chmod 555 /bin/cd.sh")
            subprocess.getstatusoutput("chmod 555 /bin/cd1.sh")
            subprocess.getstatusoutput("chmod 555 /bin/cd33.sh")
            subprocess.getstatusoutput("chmod 555 /bin/cd44.sh")
            sr = subprocess.getoutput("ls /dev | grep sr").split("\n")
            t1 = ['']
            if asd == 1:
                if sr != t1:
                    try:
                        context = pyudev.Context()
                        for i in sr:
                            a = pyudev.Devices.from_device_file(context, '/dev/{}'.format(i))
                            b = str(a)
                            c = b[b.rfind('target'):-12]
                            d = c[12:]
                            e = d.replace(':', ' ').strip("/")
                            print("1")
                            f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(e)
                            g = '''echo "scsi add-single-device {}"> /proc/scsi/scsi'''.format(e)
                            os.system(f)
                            os.system(g)
                    except Exception:
                        pass
                    os.system("chmod 440 /dev/sr*")
                else:
                    try:
                        with open('/etc/cd.json', 'r') as f:
                            sr_list = json.load(fp=f)
                        list2 = []
                        if sr_list == list2:
                            pass
                        for k in sr_list:
                            print("2")
                            f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(k)
                            g = '''echo "scsi add-single-device {}"> /proc/scsi/scsi'''.format(k)
                            os.system(f)
                            os.system(g)
                        os.system("chmod 444 /dev/sr*")
                    except Exception:
                        pass
            else:
                if sr != t1:
                    try:
                        context = pyudev.Context()
                        for i in sr:
                            a = pyudev.Devices.from_device_file(context, '/dev/{}'.format(i))
                            b = str(a)
                            c = b[b.rfind('target'):-12]
                            d = c[12:]
                            e = d.replace(':', ' ').strip("/")
                            print("3")
                            f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(e)
                            g = '''echo "scsi add-single-device {}"> /proc/scsi/scsi'''.format(e)
                            os.system(f)
                            os.system(g)
                    except Exception:
                        pass
                    os.system("chmod 440 /dev/sr*")
                else:
                    os.system("chmod 440 /dev/sr*")
                    pass
            os.system("chmod 440 /dev/sr*")
            return 0
        elif status == 2:
            if os.path.exists('/etc/udev/rules.d/cd-burn-allow.rules'):
                return 0
            if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules'):
                os.remove('/etc/udev/rules.d/cd-burn-forbid-all.rules')
                bsd = 1
            else:
                bsd = 2
            if os.path.exists('/etc/udev/rules.d/1cd-burn-forbid-all.rules'):
                os.remove('/etc/udev/rules.d/1cd-burn-forbid-all.rules')
            if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules'):
                os.remove('/etc/udev/rules.d/cd-burn-forbid-write.rules')
            
            with open('/etc/udev/rules.d/cd-burn-allow.rules', 'w') as f:
                f.write('''ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_FS_USAGE}=="filesystem",RUN+="/usr/bin/normal_in.py"
ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_FS_USAGE}=="filesystem",RUN+="/usr/bin/normal_in.py"
ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_CDROM_MEDIA_STATE}=="blank",RUN+="/usr/bin/normal_in_blank.py"
ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_CDROM_MEDIA_STATE}=="blank",RUN+="/usr/bin/normal_in_blank.py"
ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_EJECT_REQUEST}=="1",RUN+="/usr/bin/normal_out.py"
ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_EJECT_REQUEST}=="1",RUN+="/usr/bin/normal_out.py"
                                                               ''')
            t2 = ['']
            if bsd == 1:
                sr = subprocess.getoutput("ls /dev | grep sr").split("\n")
                if sr != t2:
                    os.system("chmod 666 /dev/sr*")
                else:
                    try:
                        with open('/etc/cd.json', 'r') as f:
                            sr_list = json.load(fp=f)
                        print("4")
                        for k in sr_list:
                            f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(k)
                            g = '''echo "scsi add-single-device {}"> /proc/scsi/scsi'''.format(k)
                            os.system(f)
                            os.system(g)
                    except Exception:
                        pass
            else:
                sr = subprocess.getoutput("ls /dev | grep sr").split("\n")
                if sr != t2:
                    os.system("chmod 666 /dev/sr*")
                else:
                    os.system("chmod 666 /dev/sr*")
                    pass
            return 0
        else:
            return -1

bus = SystemBus()
bus.publish("com.kylin.kysdk.CDControl", CDService())
loop.run()

